dnl acinclude.m4 generated automatically by ac-archive's acinclude 0.5.53

dnl Copyright (C) 1994, 1995-8, 1999 Free Software Foundation, Inc.
dnl This file is free software; the Free Software Foundation
dnl gives unlimited permission to copy and/or distribute it,
dnl with or without modifications, as long as this notice is preserved.

dnl This program is distributed in the hope that it will be useful,
dnl but WITHOUT ANY WARRANTY, to the extent permitted by law; without
dnl even the implied warranty of MERCHANTABILITY or FITNESS FOR A
dnl PARTICULAR PURPOSE.

dnl ______  ______

dnl ______ /usr/share/aclocal/guidod/patch_libtool_changing_cmds_ifs.m4 ______
dnl @* PATCH_LIBTOOL_CHANGING_CMDS_IFS
dnl
dnl Do a `grep "^[a-z]*_cmds=" libtool` - these are "subroutines"
dnl encoded by libtool.m4 into the generated libtool script. Since
dnl libtool assumes that there is no subroutine-facility in the
dnl shell invoked, these are not actually subroutines, but actually
dnl a "list of commands". This looks correct, but the command
dnl separator is not ";" - it is "~", the tilde character.
dnl
dnl Now, grep again, look for `grep 'IFS="~"' libtool` and see 
dnl that libtool scripting uses a for-loop on the command-list,
dnl i.e for cmd in $some_cmds. This works correctly when the
dnl IFS was modified, where IFS stands for "input field separator"
dnl which is whitespace characters by default.
dnl
dnl The problem: I have some real-world filesystems where there
dnl are directories using "~" inside of them, to be more to the
dnl point, it is a change control management software that uses
dnl source repositories of the form "path/master/project~version/src"
dnl and libtool has the tendency to resolve any symlinks so that
dnl it will paste such path into the $_cmds script when it gets
dnl evaluated a number of times.
dnl
dnl This script is a workaround: I do not know why the ";" was
dnl not chosen as the IFS, perhaps it has some weird interactions
dnl in some shells since it is also the default record separator
dnl being one time bigger in context than the argument separator.
dnl I have made good success however with using "?" as the IFS,
dnl since there is no path-name that uses a question mark, and 
dnl there is no _cmds ever around that uses "?" for some thing.
dnl
dnl Oh yes, there are some usages of "*" to match shell-wise at 
dnl the output file of some tool, so that might have triggered
dnl the choice to not use "?" in the first place - but in real
dnl life it never occured that a _cmds script was created that
dnl has gone to use "?". And so, this ac-macro exchanges the
dnl s/~/?/g in configured _cmds variables and replaces all
dnl occurences of s/IFS="~"/IFS="?"/ - and it all works smooth now.
dnl
dnl @= guidod@gmx.de
dnl @%Id: patch_libtool_changing_cmds_ifs.m4,v 1.3 2003/03/25 20:04:40 guidod Exp %

AC_DEFUN([PATCH_LIBTOOL_CHANGING_CMDS_IFS],
[# patch libtool to change $_cmds IFS from ~ to ? character
if grep "^[[_$as_cr_letters]]_cmds=.*[[?]]" libtool >/dev/null; then
  AC_MSG_WARN(dnl
  [patching libtool skipped - _cmds already contain question marks])
else
 AC_MSG_RESULT([patching libtool to change cmds IFS from ~ to ?])
    test -f libtool.old || (mv libtool libtool.old && cp libtool.old libtool)
    sed -e "/^[[_$as_cr_letters]]*_cmds=/s/~/?/g" -e 's/IFS="~"/IFS="?"/g' \
        -e "s/IFS='~'/IFS='?'/g"    libtool > libtool.new
    (test -s libtool.new || rm libtool.new) 2>/dev/null
    test -f libtool.new && mv libtool.new libtool # not 2>/dev/null !!
    test -f libtool     || mv libtool.old libtool
fi
])
dnl ______ /usr/share/aclocal/guidod/patch_libtool_on_darwin_pass_all.m4 ______
dnl @* PATCH_LIBTOOL_ON_DARWIN_PASS_ALL
dnl
dnl libtool 1.4.x on darwin uses a lib_check with a file_magic that
dnl tests for "Mach-O dynamically linked shared library". However,
dnl this is the file_magic for ".dylib" sharedlibraries but not for
dnl ".so" sharedlibraries. They have another "file -L" result of
dnl "Mach-O bundle ppc", which has an annoying result: when a
dnl a module (a .so) is dependent on another module (another .so)
dnl then libtool will error out and say that the import-module 
dnl was not found where in fact it is available. It does not even
dnl try to call the real linker.
dnl
dnl Later libtool generations have changed the processing, the
dnl import file_check has been changed from "file_magic" to
dnl "pass_all". This ac-macro does a similar thing: it checks
dnl for the darwin host, it checks for the check_method, and
dnl when it was not "pass_all" then we set it to 
dnl "deplibs_check_method=pass_all"
dnl 
dnl @= guidod@gmx.de
dnl %Id: patch_libtool_on_darwin_pass_all.m4,v 1.1 2003/03/23 13:20:27 guidod Exp %

AC_DEFUN([PATCH_LIBTOOL_ON_DARWIN_PASS_ALL],
[# libtool-1.4 specific, on darwin set deplibs_check_method=pass_all
case "$host_os" in
  darwin*)
    if grep "^deplibs_check_method=.*file_magic" libtool >/dev/null ; then
AC_MSG_RESULT(patching libtool to set deplibs_check_method=pass_all)
      test -f libtool.old || (mv libtool libtool.old && cp libtool.old libtool)
      sed -e '/^deplibs_check_method=/s/=.*/="pass_all"/' libtool >libtool.new
      (test -s libtool.new || rm libtool.new) 2>/dev/null
      test -f libtool.new && mv libtool.new libtool # not 2>/dev/null !!
      test -f libtool     || mv libtool.old libtool
    fi
  ;;
esac
])
dnl ______ /usr/share/aclocal/guidod/patch_libtool_sys_lib_search_path_spec.m4 ______
dnl @* PATCH_LIBTOOL_SYS_LIB_SEARCH_PATH_SPEC
dnl
dnl Cross-compiling to win32 from a unix system reveals a bug - the
dnl path-separator has been set to ";" depending on the target system.
dnl However, the crossgcc search_path_spec works in a unix-environment
dnl with unix-style directories and unix-stylish path_separator. The
dnl result: the search_path_spec is a single word still containing the
dnl ":" separators.
dnl
dnl This macro fixes the situation: when we see the libtool PATH_SEP
dnl to be ":" and search_path_spec to contain ":" characters, then
dnl these are replaced with spaces to let the resulting string work
dnl as a for-loop argument in libtool scripts that resolve -no-undefined
dnl libraries.
dnl
dnl Later libtool generations have fixed the situation with using
dnl $PATH_SEPARATOR in the first place as the original path delimiter
dnl that will be scanned for and replaced into spaces.
dnl
dnl @= guidod@gmx.de
dnl @%Id: patch_libtool_sys_lib_search_path_spec.m4,v 1.3 2003/03/23 13:20:27 guidod Exp %

AC_DEFUN([PATCH_LIBTOOL_SYS_LIB_SEARCH_PATH_SPEC],
[# patch libtool to fix sys_lib_search_path (e.g. crosscompiling a win32 dll)
if test "_$PATH_SEPARATOR" = "_:" ; then
  if grep "^sys_lib_search_path_spec.*:" libtool >/dev/null ; then
AC_MSG_RESULT(patching libtool to fix sys_lib_search_path_spec)
    test -f libtool.old || (mv libtool libtool.old && cp libtool.old libtool)
    sed -e "/^sys_lib_search_path_spec/s/:/ /g" libtool >libtool.new
    (test -s libtool.new || rm libtool.new) 2>/dev/null
    test -f libtool.new && mv libtool.new libtool # not 2>/dev/null !!
    test -f libtool     || mv libtool.old libtool
  fi
fi
])
dnl ______ /usr/share/aclocal/guidod/patch_libtool_to_add_host_cc.m4 ______
dnl @* PATCH_LIBTOOL_TO_ADD_HOST_CC
dnl
dnl The libtool 1.4.x processing (and patched 1.3.5) uses a little
dnl "impgen" tool to turn a "*.dll" into an import "*.lib" as it is
dnl needed for win32 targets. However, this little tool is not shipped
dnl by binutils, it is not even a command option of dlltool or dllwrap.
dnl It happens to be a C source snippet implanted into the libtool
dnl sources - it gets written to ".libs", compiled into a binary 
dnl on-the-fly, and executed right away on the "dll" file to create
dnl the import-lib (dll.a files in gcc-speak).
dnl
dnl This mode works fine for a native build within mingw or cygwin,
dnl but it does not work in cross-compile mode since CC is a
dnl crosscompiler - it will create an .exe file on a non-win32
dnl system, and as a result an impgen.exe is created on-the-fly
dnl that can not be executed on-the-fly. Luckily, the actual
dnl libtool snippet uses HOST_CC to compile the sources which
dnl has a fallback to CC when the HOST_CC variable was not set.
dnl
dnl this ac-macro is trying to detect a valid HOST_CC which is not
dnl a cross-compiler. This is done by looking into the $PATH for
dnl a "cc" and the result is patched into libtool a HOST_CC, iow
dnl it adds another configured variable at the top of the libtool
dnl script.
dnl
dnl In discussions on the libtool mailinglist it occurred that
dnl later gcc/binutils generations are able to link with dlls 
dnl directly, i.e. there is no import-lib needed anymore. The
dnl import-table is created within the linker itself (in-memory)
dnl and bound to the .exe/.dll currently in the making. The
dnl whole stuff of impgen exe and compiling it on-the-fly, well,
dnl it is superflouos then. 
dnl
dnl Since mingw crosscompilers tend to be quite a fresh development
dnl it was agreed to remove the impgen stuff completly from
dnl libtool sources. Still however, this macro does not hurt
dnl since it does not patch impgen cmds but it just adds HOST_CC
dnl which might be useful in other cross-compiling cases as well.
dnl Therefore, you can leave it in for maximum compatibility and
dnl portability.
dnl
dnl @= guidod@gmx.de
dnl @%Id: patch_libtool_to_add_host_cc.m4,v 1.3 2003/03/23 13:20:27 guidod Exp %

AC_DEFUN([PATCH_LIBTOOL_TO_ADD_HOST_CC],
[# patch libtool to add HOST_CC sometimes needed in crosscompiling a win32 dll
if grep "HOST_CC" libtool >/dev/null; then
  if test "$build" != "$host" ; then
    if test "_$HOST_CC" = "_" ; then
      HOST_CC="false"
      for i in `echo $PATH | sed 's,:, ,g'` ; do
      test -x $i/cc && HOST_CC=$i/cc
      done
    fi
AC_MSG_RESULT(patching libtool to add HOST_CC=$HOST_CC)
    test -f libtool.old || (mv libtool libtool.old && cp libtool.old libtool)
    sed -e "/BEGIN.*LIBTOOL.*CONFIG/a\\
HOST_CC=$HOST_CC" libtool >libtool.new
    (test -s libtool.new || rm libtool.new) 2>/dev/null
    test -f libtool.new && mv libtool.new libtool # not 2>/dev/null !!
    test -f libtool     || mv libtool.old libtool
  fi
fi
])
dnl ______ /usr/share/aclocal/guidod/patch_libtool_on_darwin_zsh_overquoting.m4 ______
dnl @* PATCH_LIBTOOL_ON_DARWIN_ZSH_OVERQUOTING
dnl
dnl libtool 1.4.x has a bug on darwin where the "zsh" is installed
dnl as the bourne shell replacement. Of course, the zsh is called in
dnl a compatibility mode but there is a common problem with it,
dnl probably a bug of zsh. Newer darwin systems have a "bash"
dnl installed now, but the configure-default will be "zsh" in most
dnl systems still.
dnl
dnl The bug revelas itself as an overquoted statement in the
dnl libtool cmds-spec for sharedlib creation on testing for
dnl "module" builds. Later libtool has gone rid of it by simply
dnl removing the quotes at that point . Here we maintain the 
dnl original style and simply remove the extra escape character,
dnl i.e. we look for "archive_cmds" and replace a sequence of
dnl triple-backslash-and-doublequote with single-backslash-and-doublequote.
dnl 
dnl @= guidod@gmx.de
dnl %Id: patch_libtool_on_darwin_zsh_overquoting.m4,v 1.4 2003/03/24 16:58:21 guidod Exp %

AC_DEFUN([PATCH_LIBTOOL_ON_DARWIN_ZSH_OVERQUOTING],
[# libtool-1.4 specific, on zsh target the final requoting does one too much
case "$host_os" in
  darwin*)
    if grep "1.92" libtool >/dev/null ; then
AC_MSG_RESULT(patching libtool on .so-sharedlib creation (zsh overquoting))
      test -f libtool.old || (mv libtool libtool.old && cp libtool.old libtool)
      sed -e '/archive_cmds=/s:[[\\]][[\\]][[\\]]*":\\":g' libtool >libtool.new
      (test -s libtool.new || rm libtool.new) 2>/dev/null
      test -f libtool.new && mv libtool.new libtool # not 2>/dev/null !!
      test -f libtool     || mv libtool.old libtool
    fi
  ;;
esac
])
